Public Delegate Function MyFxDelegate(ByVal nNumVars As Integer, ByRef fX() As Double, ByRef fParam() As Double) As Double
Public Delegate Function SayFxDelegate() As String

Public Class CDirectSearch

  Public Function DirectSearch(ByVal nNumVars As Integer, ByRef fX() As Double, ByRef fParam() As Double, _
                  ByRef fStepSize() As Double, ByRef fMinStepSize() As Double, ByRef nIter As Integer, _
                  ByVal MyFx As MyFxDelegate) As Double
    Const StepReduceFactor As Integer = 10

    Dim fBestF As Double
    Dim F, fXX As Double
    Dim I As Integer
    Dim bStop, bFound As Boolean

    fBestF = MyFx(nNumVars, fX, fParam)

    nIter = 0
    Do
      nIter = nIter + 1

      For I = 0 To nNumVars - 1
        bFound = False
        Do
          fXX = fX(I)
          fX(I) = fXX + fStepSize(I)
          F = MyFx(nNumVars, fX, fParam)
          If F < fBestF Then
            fBestF = F
            bFound = True
          Else
            fX(I) = fXX - fStepSize(I)
            F = MyFx(nNumVars, fX, fParam)
            If F < fBestF Then
              fBestF = F
              bFound = True
            Else
              fX(I) = fXX
              If Not bFound Then
                fStepSize(I) = fStepSize(I) / StepReduceFactor
              End If
              Exit Do
            End If
          End If
        Loop
      Next I

      bStop = True
      For I = 0 To nNumVars - 1
        If fStepSize(I) >= fMinStepSize(I) Then
          bStop = False
          Exit For
        End If
      Next I

    Loop Until bStop

    Return fBestF

  End Function
End Class

